(* = DiffAppl.ML
   +++ outcommented tests
*)


theory' := overwritel (!theory', [("DiffAppl.thy",DiffAppl.thy)]);

(* 
> get_pbt ["DiffAppl.thy","maximum_of","function"];
> get_met ("Script.thy","max_on_interval_by_calculus");
> !pbltypes;
  *)
pbltypes:= overwritel (!pbltypes,
[
 prep_pbt DiffAppl.thy
 (["DiffAppl.thy","maximum_of","function"],
  [("#Given" ,"fixedValues fix_"),
   ("#Find"  ,"maximum m_"),
   ("#Find"  ,"valuesFor vs_"),
   ("#Relate","relations rs_")  (*,
   ("#where" ,"foldl (op&) True (map (Not o ((op<=) #0) o Rhs) fix_)"),
   ("#with"  ,"Ex_frees ((foldl (op &) True rs_) &  \
    \ (ALL m'. (subst (m_,m') (foldl (op &) True rs_) \
    \            --> m' <= m_)))")    *)
  ]),

 prep_pbt DiffAppl.thy
 (["DiffAppl.thy","make","function"]:pblID,
  [("#Given" ,"functionOf f_"),
   ("#Given" ,"boundVariable v_v"),
   ("#Given" ,"equalities eqs_"),
   ("#Find"  ,"functionTerm f_0_")
  ]),

 prep_pbt DiffAppl.thy
 (["DiffAppl.thy","on_interval","maximum_of","function"]:pblID,
  [("#Given" ,"functionTerm t_"),
   ("#Given" ,"boundVariable v_v"),
   ("#Given" ,"interval itv_"),
   ("#Find"  ,"maxArgument v_0_")
  ]),

 prep_pbt DiffAppl.thy
 (["DiffAppl.thy","find_values","tool"]:pblID,
  [("#Given" ,"maxArgument ma_"),
   ("#Given" ,"functionTerm f_"),
   ("#Given" ,"boundVariable v_v"),
   ("#Find"  ,"valuesFor vls_"),
   ("#Relate","additionalRels rs_")
  ])
]);


methods:= overwritel (!methods,
[
 (("DiffAppl.thy","max_by_calculus"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"fixedValues fix_"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"interval itv_"),
    ("#Given" ,"errorBound err_"),
    ("#Find"  ,"maximum m_"),
    ("#Find"  ,"valuesFor vs_"),
    ("#Relate","relations rs_")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),

 (("DiffAppl.thy","make_fun_by_new_variable"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"functionOf f_"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"equalities eqs_"),
    ("#Find"  ,"functionTerm f_0_")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),

 (("DiffAppl.thy","make_fun_by_explicit"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"functionOf f_"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"equalities eqs_"),
    ("#Find"  ,"functionTerm f_0_")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),
  
 (("DiffAppl.thy","max_on_interval_by_calculus"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"functionTerm t_"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"interval itv_"),
    ("#Given" ,"errorBound err_"),
    ("#Find"  ,"maxArgument v_0_")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),

 (("DiffAppl.thy","find_values"):metID,
  {ppc = prep_met DiffAppl.thy
   [],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met)
]);
